load prec_ann  % subjects who completed all 5 bursts
data = prec_ann;
% load prec_noann  % subjects who completed only burst 1 and 5
% data = prec_noann;

% set bounds for parameter search
max_age_change_per_year = 0.025;  %maximum change of 2.5% prec per year
lb=[0, -.5, .1, -max_age_change_per_year/365]; %Lower bounds of parameters
ub=[1, .5, 1, max_age_change_per_year/365]; %Upper bounds of parameters

grid_size = 120; % point per dimension in the gridsearch
n_check = 1000;  % minimize the best n_check from the grid

% run the grid search on each subject
% NOTE: this is run in parallel using all abailabvle cores on your machine
parfor subj= 1:size(data.prec, 1)
    
    % pull out some info from the data structure and format it
    p_rec= data.prec(subj, :);
    p_rec = p_rec(~isnan(p_rec));
    date = data.date(subj, :);
    date = date(~isnan(date));
    age = (data.age(subj)*365)+date;
    
    bestX(subj, :) = grid_search(p_rec, date, age, lb, ub, grid_size, n_check);
  
end