function [X_best] = karls_fitting_alg(p_rec, date, age, lb, ub, grid_size, n_check)

% fmincon settings
A = [];
b = [];
Aeq = [];
beq = [];
n_params = length(lb);
options = [];
options.MaxIter = 5000*n_params;

for p = 1:n_params
    try_x(:,p) = linspace(lb(p), ub(p), grid_size)';
end

%Calculating rmsd for all possible combinations of parameter values
best_fit = repmat(realmax,[n_check,1]);
bestX_grid = nan(n_check,n_params);
for h = 1:grid_size
    for i = 1:grid_size
        for j = 1:grid_size
            for k = 1:grid_size
                
                % eval and check if min rather than keeping everything
                cur_fit = rmsd(p_rec, date, age, [try_x(h, 1), try_x(i, 2), try_x(j,3 ), try_x(k, 4)]);
                if any(cur_fit < best_fit)
                    
                    % find the index to the worst of the best and replace it
                    worst = find(max(best_fit) == best_fit, 1);
                    best_fit(worst) = cur_fit;
                    bestX_grid(worst, :) = [try_x(h, 1), try_x(i, 2), try_x(j,3 ), try_x(k, 4)];
                    
                end
 
            end
        end
    end
end

% run fmincon on each of the n_check best sets from the grid search
myfunc=@(X) rmsd(p_rec, date, age, X);
for grid = 1:n_check
    [bestX_min(grid, :), ~] = fmincon(myfunc, bestX_grid(grid, :),A,b,Aeq,beq,lb,ub, [],options);
end
best_set = find(min(chi2_min) == chi2_min, 1);
X_best = bestX_min(best_set, :);